#pragma semicolon 1


#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.0"

new Handle:ModifyPiano = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "DOD:S AvalanchePiano",
	author = "Ben",
	description = "removes or fixes piano on avalanche maps",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.com"
}

public OnPluginStart()
{
	CreateConVar("dod_avapiano_ver", PLUGIN_VERSION, "DOD:S AvalanchePiano(DO NOT CHANGE!)", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	SetConVarString(FindConVar("dod_avapiano_ver"), PLUGIN_VERSION);
	ModifyPiano = CreateConVar("dod_avalanchepiano", "2", "<2/1/0> 2 = fix piano (default) / 1 = remove piano / 0 = no modification (OFF)", FCVAR_PLUGIN, true, 0.0, true, 2.0);
	HookEventEx("dod_round_active", OnRound, EventHookMode_Post);
	HookEventEx("dod_round_start", OnRound, EventHookMode_Post);
}

public Action:OnRound(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(ModifyPiano) > 0)
	{
		new String:mapname[256];
		GetCurrentMap(mapname, sizeof(mapname));
		if(StrContains(mapname, "avalanche") != -1)
		{
			new entid = -1;
			while((entid = FindEntityByClassname(entid, "prop_physics_multiplayer")) != -1)
			{
				new Float:piano_loc[3];
				GetEntPropVector(entid, Prop_Send, "m_vecOrigin", piano_loc);
				new iOrigin[3];
				iOrigin[0] = RoundFloat(piano_loc[0]);
				iOrigin[1] = RoundFloat(piano_loc[1]);
				iOrigin[2] = RoundFloat(piano_loc[2]);
				if(iOrigin[0] == 719 && iOrigin[1] == 82 && iOrigin[2] == 96)
				{
					Modify(entid);
					return Plugin_Continue;
				}
			}
		}
	}
	return Plugin_Continue;
}

public Modify(entid)
{
	if (entid > 0 && IsValidEntity(entid))
	{
		if (GetConVarInt(ModifyPiano) == 1)
			AcceptEntityInput(entid, "kill");
		else if (GetConVarInt(ModifyPiano) == 2)
			SetEntityMoveType(entid, MOVETYPE_NONE);
	}
}